



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>实现MyArrayList类深入理解ArrayList</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">实现MyArrayList类深入理解ArrayList</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 07:23:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>ArrayList简介</h3>
<p>ArrayList是一个动态数组，Array的复杂版本，它提供了动态的增加和减少元素，实现了ICollection和IList接口，灵活的设置数组的大小等好处，ArrayList不是线程安全的。</p>
<h3>MyArrayList</h3>
<p>在实现MyArrayList前先实现MyList，MyAbstractList，他们的关系如下。</p>
<p><strong>MyArrayList---&gt;（继承于）MyAbstractList---&gt;（实现）MyList接口---&gt;（实现）java.lang.Iterable接口</strong></p>
<h3>通过编写新的ArrayList来实现java中ArrayList的部分功能</h3>
<p>MyList接口定义如下</p>
<div>
<pre class="prettyprint linenums">public interface MyList&lt;E&gt; extends Iterable&lt;E&gt; {

    public void add(E e);<br />
    public void add(int index, E e);<br />
    public void clear();<br />
    public boolean contains(E e);<br />
    public E get(int index);<br />
    public int indexOf(E e);<br />
    public boolean isEmpty();<br />
    public int lastIndexOf(E e);<br />
    public boolean remove(E e);<br />
    public E remove(int index);<br />
    public E set(int index, E e);<br />
    public int size();<br />
}</pre>
</div>
<p>MyAbstractList类定义如下</p>
<div>
<pre class="prettyprint linenums">public abstract class MyAbstractList&lt;E&gt; implements MyList&lt;E&gt; {

    protected int size = 0;

    protected MyAbstractList() {

    }

    protected MyAbstractList(E[] objects) {<br />
        for(int i = 0; i &lt; objects.length; i++) {<br />
            add(objects[i]);<br />
        }<br />
    }

    @Override<br />
    public void add(E e) {<br />
        add(size, e);<br />
    }

    @Override<br />
    public boolean isEmpty() {<br />
        return size == 0;<br />
    }

    @Override<br />
    public int size() {<br />
        return size;<br />
    }

    @Override<br />
    public boolean remove(E e) {<br />
        if(indexOf(e) &gt;= 0) {<br />
            remove(indexOf(e));<br />
            return true;<br />
        }else {<br />
            return false;<br />
        }<br />
    }<br />
}</pre>
</div>
<p>MyArrayList定义如下</p>
<div>
<pre class="prettyprint linenums">import java.util.Iterator;

public class MyArrayList&lt;E&gt; extends MyAbstractList&lt;E&gt; {<br />
    public static final int INITIAL_CAPACITY = 16;//初始容量<br />
    private E[]data = (E[])(new Object[INITIAL_CAPACITY]);;

    public MyArrayList() {<br />
    }

    public MyArrayList(int length) {<br />
        if(length &gt;= 0) {<br />
            data = (E[])(new Object[length]);<br />
        }<br />
    }

    public MyArrayList(E[] objects) {<br />
        for(int i = 0; i &lt; objects.length; i++) {<br />
            add(objects[i]);<br />
        }<br />
    }

    @Override<br />
    public void add(int index, E e) {<br />
        // TODO Auto-generated method stub<br />
        ensureCapacity();

        for(int i = size - 1; i &gt;= index; i--) {//将data[index]和后面的元素往后移动一位<br />
            data[i + 1] = data[i];<br />
        }

        data[index] = e;<br />
        size++;<br />
    }

    //判断容量满时，新建一个容量为原来两倍+1的数组<br />
    private void ensureCapacity() {<br />
        if(size &gt;= data.length) {<br />
            E[] newData = (E[])(new Object[size * 2 + 1]);//java源码扩容1.5倍＋1<br />
            System.arraycopy(data, 0, newData, 0, size);<br />
            data = newData;<br />
        }<br />
    }

    @Override<br />
    public void clear() {<br />
        // TODO Auto-generated method stub<br />
        data = (E[])(new Object[INITIAL_CAPACITY]);<br />
        size = 0;<br />
    }

    @Override<br />
    public boolean contains(E e) {<br />
        // TODO Auto-generated method stub<br />
        for(int i = 0; i &lt; size; i++) {<br />
            if(e.equals(data[i])) {<br />
                return true;<br />
            }<br />
        }<br />
        return false;<br />
    }

    @Override<br />
    public E get(int index) {<br />
        // TODO Auto-generated method stub<br />
        checkIndex(index);//判断下标是否合法<br />
        return data[index];<br />
    }

    private void checkIndex(int index) {<br />
        if(index &lt; 0 || index &gt;= size) {<br />
            throw new IndexOutOfBoundsException("index " + index + " out of bounds");<br />
        }<br />
    }

    @Override<br />
    public int indexOf(E e) {<br />
        // TODO Auto-generated method stub<br />
        for(int i = 0; i &lt; size; i++) {<br />
            if(e.equals(data[i])) {<br />
                return i;<br />
            }<br />
        }<br />
        return -1;<br />
    }

    @Override<br />
    public int lastIndexOf(E e) {<br />
        // TODO Auto-generated method stub<br />
        for(int i = size - 1; i &gt;= 0; i--) {<br />
            if(e.equals(data[i])) {<br />
                return i;<br />
            }<br />
        }<br />
        return -1;<br />
    }

    @Override<br />
    public E remove(int index) {<br />
        // TODO Auto-generated method stub<br />
        checkIndex(index);//判断下标是否合法<br />
        E e = data[index];//获取删除对象的值

        for(int i = index; i &lt; size - 1; i++) {//将data[index]后面的元素往前移动一位<br />
            data[i] = data[i+1];<br />
        }

        data[size] = null;//删除最后的元素<br />
        size--;<br />
        return e;<br />
    }

    @Override<br />
    public E set(int index, E e) {<br />
        // TODO Auto-generated method stub<br />
        checkIndex(index);//判断下标是否合法<br />
        E old = data[index];<br />
        data[index] = e;<br />
        return old;<br />
    }

    //重写java.lang.Object.toString方法，打印整个数组<br />
    @Override<br />
    public String toString() {<br />
        StringBuilder result = new StringBuilder("[");

        for(int i = 0; i &lt; size; i++) {<br />
            result.append(data[i]);<br />
            if(i &lt; size - 1) {<br />
                result.append(",");<br />
            }<br />
        }

        return result + "]";<br />
    }

    //新建一个刚好等于size的数组，即将数组容量设为刚好足够存放的大小<br />
    public void trimToSize() {<br />
        if(size != data.length) {<br />
            E[] newData = (E[])(new Object[size]);<br />
            System.arraycopy(data, 0, newData, 0, size);<br />
            data = newData;<br />
        }<br />
    }

    @Override<br />
    public Iterator&lt;E&gt; iterator() {<br />
        // TODO Auto-generated method stub<br />
        return new ArrayListIterator();<br />
    }

    private class ArrayListIterator implements Iterator&lt;E&gt; {<br />
        private int current = 0;

        @Override<br />
        public boolean hasNext() {<br />
            // TODO Auto-generated method stub<br />
            return (current &lt; size);<br />
        }

        @Override<br />
        public E next() {<br />
            // TODO Auto-generated method stub<br />
            return data[current++];<br />
        }<br />
    }<br />
}</pre>
</div>
<p>测试代码如下</p>
<div>
<pre class="prettyprint linenums">public class TestMyArrayList {

    public static void main(String[] args) {<br />
        // TODO Auto-generated method stub

//        String[] ss = {"China","America","Germany","Canada","France","Germany"};<br />
        MyList&lt;String&gt; list = new MyArrayList&lt;String&gt;();<br />
        System.out.println("测试add(E e)方法和add(int index, E e)方法添加数据。");<br />
        list.add("America");<br />
        list.add(0,"China");<br />
        list.add("Canada");<br />
        list.add("France");<br />
        list.add(2,"Germany");<br />
        list.add("Germany");<br />
        System.out.println("通过toString()方法打印数组" + list.toString());<br />
        System.out.println("通过size()方法获取长度：" + list.size());<br />
        System.out.println("测试contains()方法：" + list.contains("France"));<br />
        System.out.println("通过get()方法获取指定下标的值：" + list.get(1));<br />
        System.out.println("通过indexOf()方法获取指定值的下标：" + list.indexOf("Germany"));<br />
        System.out.println("通过lastIndexOf()方法获取最后出现的指定值的下标：" + list.lastIndexOf("Germany"));<br />
        System.out.println("通过下标删除指定值：" + list.remove(5));<br />
        System.out.println("删除后的数组：" + list.toString());<br />
        System.out.println("通过set()方法修改值：" + list.set(2, "Russia"));<br />
        System.out.print("通过foreach遍历数组：");<br />
        for(String s:list) {<br />
            System.out.print(s.toUpperCase() + " ");<br />
        }<br />
    }

}</pre>
</div>
<p>测试结果</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1365770/201805/1365770-20180511214853609-1519195547.png" /></p>
<p>思考：为什么MyArrayList类中的ensureCapacity()扩容倍数是2 * x + 1而不是2 * x？</p>
<p>因为如果我们创建了一个长度为0的数组，如果扩容倍数是2 * x，那么这个数组就无法扩容了。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqloj7xq.html">arcgis desktop 10&period;1 license manager无法启动问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g4z5z9.html">hasOwnProperty 递归 简单回调 链式调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7130kq.html">RAC One Node转换为RAC</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyz46d9.html">金山快盘有Linux版了</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1x0jq.html">spring 初始化时注入bean实现listener的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd57g48.html">CXF发布restful WebService的入门例子&lpar;客户端&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mverjq.html">&lbrack;翻译&rsqb; GVUserDefaults</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm7rve9.html">&lbrack;置顶&rsqb; Hash查找&comma;散列查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zgky09.html">C&plus;&plus;赋值运算符、函数调用运算符、下标运算符（&OpenCurlyDoubleQuote;&equals;&rdquo;、&OpenCurlyDoubleQuote;（）&rdquo;、&OpenCurlyDoubleQuote;&lbrack;&rsqb;&rdquo;）重载</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m72wm8.html">BZOJ 1612&colon; &lbrack;Usaco2008 Jan&rsqb;Cow Contest奶牛的比赛&lpar; floyd &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zm7rk9.html">Selenium WebDriver   TestNg  Maven  Eclipse java 简单实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkl04e8.html">hrbustoj 1985（进制转换函数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjnldr8.html">&lbrack;2015-11-23&rsqb;分享一个批处理脚本，创建iis站点及程序池</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m1ovo8.html">Mongo查询关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge03578.html">java8 - IO</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdo47z9.html">zlib 压缩输出缓冲区 overflow 问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdrv2k9.html">Java 多线程加锁的方式总结及对比（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zx2zj9.html">Consequence of Point-by-Point Bounds</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wwnjwq.html">【腾讯Bugly干货分享】经典随机Crash之二：Android消息机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wlj7zq.html">win10重复安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8me7my0q.html">javascript之BOM浏览器对象模型引入</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gevml08.html">python面向对象小练习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj3j619.html">viewpager循环滚动和自动轮播的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmvwk8.html">Mahout系列之-----相似度</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zy7ok9.html">&period;NET&lpar;C&num;&rpar;连接各类数据库代码-集锦</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jlx0l8.html">SQL-Teradata基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz4evg8.html">C语言中数组转化为字符串的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pw7rn8.html">linux下ruby使用tcl&sol;tk编程环境设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgvg39.html">PS 滤镜算法原理&mdash;&mdash;照亮边缘</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpgvwj9.html">程序设计之---单例模式VS静态方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
